#include "treeitem.h"

TreeItem::TreeItem(const QVariantMap &data, TreeItem *parent)
    : m_mapData(data), m_parentItem(parent)
{
}

TreeItem::~TreeItem()
{
    qDeleteAll(m_childItems);
}

void TreeItem::appendChild(TreeItem *child)
{
   m_childItems.append(child);
}

TreeItem *TreeItem::child(int row)
{
  if (row < 0 || row >= m_childItems.size())
          return nullptr;
   return m_childItems.at(row);
}

int TreeItem::childCount() const
{
   return m_childItems.count();
}

int TreeItem::columnCount() const
{
    return m_mapData.count();
}

QVariant TreeItem::data(QString columnName) const
{
    if (columnName == "")
            return QVariant();
    return m_mapData[columnName];
}


int TreeItem::row() const
{
   if (m_parentItem)
        return m_parentItem->m_childItems.indexOf(const_cast<TreeItem*>(this));
   return 0;
}

TreeItem *TreeItem::parentItem()
{
   return m_parentItem;
}
