#ifndef TREEITEM_H
#define TREEITEM_H

#include <QObject>
#include <QVariant>
#include <QVariantMap>


class TreeItem
{
public:
    explicit TreeItem(const QVariantMap &data, TreeItem *parentItem = nullptr);
    ~TreeItem();

    void appendChild(TreeItem *child);

    TreeItem *child(int row);
    int childCount() const;
    int columnCount() const;
    QVariant data(QString columnName) const;
    int row() const;
    TreeItem *parentItem();

private:
    QVector<TreeItem*> m_childItems;
    QVariantMap m_mapData;
    TreeItem *m_parentItem;
};

#endif // TREEITEM_H
